//mplabC32
//#define MAJOR_VERSION 2
//#define MINOR_VERSION 02


//CHIP Configuration PRAGMA's

// Configuring the Device Configuration Registers
// 40Mhz Core/Periph, Pri Osc w/PLL, Write protect Boot Flash

//SEE COMPILER HELP DOC ON CONFIG SETTINGS 

//running on internal 8MHz osc.


// ***************************** config for pic32mx120F032B **********************************

//set to off for FRC internal oscillator (have to do this to free up the osci/osco pins RA2, RA3)
#pragma config POSCMOD = OFF					//Primary Oscillator mode {XT, EC, HS, OFF}

//note: XT, EC, HS modes are only for an External Oscillator!
//#pragma config POSCMOD = XT					//Primary Oscillator mode {XT, EC, HS, OFF}


//setup FRC oscillator (main internal osc)
#pragma config FNOSC = FRCPLL				// Fast RC Oscillator with divide-by-N with PLL module (FRCDIV+PLL)

#pragma config FPLLMUL = MUL_20 			//PLL multiplier
#pragma config FPLLIDIV = DIV_2				//PLL input divider
#pragma config FPLLODIV = DIV_2 			//PLL output divider

#pragma config FPBDIV = DIV_1				//Peripheral Clock Divisor:



//#pragma config OSCIOFNC = OFF				//clk0 output signal active on osc0 pin


#pragma config FSOSCEN = OFF				//disable secondary osc. input


#pragma config FWDTEN = OFF					//watchdog timer enable
//#pragma config WDTPS = PS4096				//watchdog timer divider


#pragma config FCKSM = CSDCMD				//Clock Switch Disable, FSCM Disabled  
//#pragma config FCKSM = CSECMD				//Clock Switch Enable, FSCM Disabled  
//#pragma config FCKSM = CSECME				//Clock Switch Enable, FSCM Enabled  


#pragma config PMDL1WAY = OFF				//Peripheral Module Disable Configuration: OFF=>Allow multiple reconfigurations; ON=>Allow ONLY ONE reconfigurations  

#pragma config IOL1WAY = OFF				//Peripheral Pin Select Configuration: OFF=>Allow multiple reconfigurations; ON=>Allow ONLY ONE reconfigurations  


#pragma config JTAGEN = OFF					//jtag port on/off

//#pragma config PWP = PWP10K					//program flash write protect (first xk bytes)
#pragma config PWP = OFF					//program flash write protect (first xk bytes)

#pragma config ICESEL = ICS_PGx3 			//which PGDx channel to debug on

//#pragma config BWP = ON						//Boot flash write protect
#pragma config BWP = OFF						//Boot flash write protect

#pragma config CP = OFF						//CODE PROTECT

#define SYS_FREQ (40000000L)

// *************************** end config for pic32mx120F032B ****************************


// ***************************** config for pic32mx340F512H Olimex board **********************************
/*
#pragma config POSCMOD = XT					//Primary Oscillator mode {XT, EC, HS, OFF}
#pragma config FNOSC = PRIPLL				// Primary Oscillator with with PLL module (XT+, HS+, EC+PLL)

#pragma config FPLLMUL = MUL_20 			//PLL multiplier
#pragma config FPLLIDIV = DIV_2				//PLL input divider
#pragma config FPLLODIV = DIV_2 			//PLL output divider

#pragma config FPBDIV = DIV_1				//Peripheral Clock Divisor:

#pragma config OSCIOFNC = ON				//clk0 output signal active on osc0 pin (believe req'd for crystal op)

#pragma config FSOSCEN = OFF				//secondary oscillator enable

#pragma config FWDTEN = OFF					//watchdog timer enable
#pragma config WDTPS = PS4096				//watchdog timer divider


#pragma config FCKSM = CSDCMD				//Clock Switch Disable, FSCM Disabled  
//#pragma config FCKSM = CSECMD				//Clock Switch Enable, FSCM Disabled  
//#pragma config FCKSM = CSECME				//Clock Switch Enable, FSCM Enabled  




//#pragma config PWP = PWP10K					//program flash write protect (first xk bytes)
#pragma config PWP = OFF

//#pragma config ICESEL = ICS_PGx2 			//which PGDx channel to debug on
//#pragma config BWP = ON						//Boot flash write protect
#pragma config BWP = OFF

*/


// *************************** end config for pic32mx120F032B ****************************

#define SYS_FREQ (40000000L)
#define PB_DIV                 1
#define T1_PRESCALE            256
#define T1_TICK               (SYS_FREQ/PB_DIV/PRESCALE)



#define	GetSystemClock() 			(40000000ul)
#define	GetPeripheralClock()		(GetSystemClock()/(1 << OSCCONbits.PBDIV))
#define	GetInstructionClock()		(GetSystemClock())



#include <p32xxxx.h>
//#include <proc\p32mx150f128b.h>

//#include <plib.h>
//#include <math.h>

//#include "uart.h"
//#include "adc.h"


#define round rint


unsigned int pbClk=1;

