//String utils





//get 1st param in token split string (',' is token)
//removes all white space till ',' is reached
//Returns: position of comma
int getStringParam_in_csv(unsigned char* chBuffer, unsigned char* chParam, int maxChars)
{
   unsigned char ch;
   unsigned char* chPtrIn;
   unsigned char* chPtrOut;
   int i;

	chPtrIn = chBuffer;
	chPtrOut = chParam;

	for(i=0;i<maxChars;i++)
	{
		ch = *chPtrIn++;
	
		if( (ch >= 33)&&(ch <= 122) )	//only allow alpha numerics and special chars #$#$%@!,
		{

			*chPtrOut++ = ch;
	
			//check for token
			if(ch == ',')
			{
				*chPtrOut =0;
				return i;
			}
		}

		//check for null terminator for this string
		if(ch == 0x00)
		{
			*chPtrOut =0;
			return(-1*i);
		}

		//check for carriage return
		if(ch == 0x0D)
		{
			*chPtrOut =0;
			return(-1*i);
		}

	}
	
}

//get param list of integers in csv string
//returns # parms if successful, returns 0 otherwise, returns values in list in parms ptr, numParms is expected # of parms to get
//note: if numParms is > #parms; will load the ones it found into *parms and then returns # it found
int getIntegerParam_in_csv(unsigned char* chBuffer, int maxChars, int* params, int numParms)
{
   unsigned char ch;
   unsigned char chParam[80];
   unsigned char* chPtr, *chInPtr;
   int val, *parms;
   int pos, i;

	parms = params;

	chPtr = (unsigned char*)&chParam[0];

	chInPtr = chBuffer;
	
	for(i=0;i<numParms;i++)
	{

		pos = getStringParam_in_csv(chInPtr, chPtr, maxChars);


		//need to check if valid #
		val = atoi(chPtr);
	
		if(val == 0)
		{
			return(i);  //could also return if we got less than spec'd parms
		}


		*parms++ = val;

		chInPtr += pos+1;

                
                if(pos < 0)
                    return(i);
	
	}
	
		

	return(i+1);

}

//returns # of parms found
//exits if parm is less than 0
int getFloatParam_in_csv(unsigned char* chBuffer, int maxChars, float* params, int numParms)
{
   unsigned char ch;
   unsigned char chParam[80];
   unsigned char* chPtr, *chInPtr;
   float val, *parms;
   int pos, i;

	parms = params;

	chPtr = (unsigned char*)&chParam[0];

	chInPtr = chBuffer;

	for(i=0;i<numParms;i++)
	{
		pos = getStringParam_in_csv(chInPtr, chPtr, maxChars);

                //if nothing found, pos==0, so break
                if(pos == 0)
                    break;

		//need to check if valid #
		val = atof(chPtr);

		if(val < 0.0)
		{
			return(i);  //could also return if we got less than spec'd parms
		}

		*parms++ = val;

		chInPtr += pos+1;


	}



	return(i+1);

}