#include <p32xxxx.h>
#include <plib.h>

#include "delay_time.h"

//#define DEFAULT_BAUDRATE 			4800	
//#define DEFAULT_BAUDRATE 			9600
#define DEFAULT_BAUDRATE 			115200	//works
//#define DEFAULT_BAUDRATE 			460800	//doesn't work
//#define DEFAULT_BAUDRATE 			921600	//doesn't work
//#define DEFAULT_BAUDRATE 			230400	//kinda works, but way too many dropped bits so really doesn't work


#define TX_IOPort	IOPORT_B
#define TX_IOPin	BIT_4

extern unsigned int pbClk;

extern volatile unsigned int an_selA_val;  //analog select register A
extern volatile unsigned int an_selB_val;  //analog select register B

//extern char* pRxBuf;
//extern char* pTxBuf;


// *****************************************************************************
// *****************************************************************************
// Section: Constant Data
// *****************************************************************************
// *****************************************************************************
const char mainMenu[] =
{
    "\r\n\r\n\r\n"
    "Welcome to USDA-ARS Cotton Bale Moisture Sensor Demo!\r\n"\
    "\r\n\r\n\r\n"
};



//  ******************* COMM SETUP  *****************************

	int maxChars = 80;
	UINT8 RxBUFFER[80];
	UINT8 TxBUFFER[80];	//main buffer for serial COMM

  char* pTxBuf = (char*) &TxBUFFER[0];
  char* pRxBuf = (char*) &RxBUFFER[0];	//stationary ptr at head of buffer

  int rxIndx = 0;	//moving ptr; keeps track of where we are in buffer as we're loading data



//#define	GetPeripheralClock()		(GetSystemClock()/(1 << OSCCONbits.PBDIV))
//#define	GetInstructionClock()		(GetSystemClock())


//static unsigned char TxBuff[255];


//pbClk defined in init.h
//void __attribute__((section (".boot_flash"))) uart1Init()
void uart1Init()
{  //unsigned int val=0;

//	val = ANSELA;
//	val = ~BIT_4;

//ANSELA = 0xffffffff;
//ANSELB = 0xffffffff;

//must set bits for analog port to be active;
//conversely for digital must clear approp. bit-mask
	ANSELA = an_selA_val & (~BIT_0);	//must de-select all analog select bits for any digital I/O or digital function
//	ANSELB = (~BIT_4);	//must de-select all analog select bits for any digital I/O or digital function
	an_selA_val = ANSELA;
//	val = ANSELB;

	PORTSetPinsDigitalOut(IOPORT_A, BIT_0);	//SET RPA0 to TX
	PORTSetPinsDigitalIn(IOPORT_A, BIT_2);	//SET RPA2 to RX

        //quick test to verify we've turned off Analog Select
	mPORTAClearBits(BIT_0);
	mPORTASetBits(BIT_0);
	mPORTAClearBits(BIT_0);
	mPORTASetBits(BIT_0);



	//set up peripheral pins for uart-1 (pic32mx1xx/2xx; i.e. pic32mx120F032B)
//	U1RXR = 2;	 //pin mask for U1RX; data-sheet page 146: 61168C.pdf
//	RPB4R = 1;	//pin mask for U1TX;  data-sheet page 148

    U1RXRbits.U1RXR = 0; //SET RPA2 to RX
    RPA0Rbits.RPA0R = 1; //SET RPB4 to TX


    //UARTConfigure(UART1, UART_ENABLE_PINS_TX_RX_ONLY | UART_ENABLE_PINS_CTS_RTS);	//use this if using hardware flow control
    UARTConfigure(UART1, UART_ENABLE_PINS_TX_RX_ONLY );
    UARTSetFifoMode(UART1, UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY);
    UARTSetLineControl(UART1, UART_DATA_SIZE_8_BITS | UART_PARITY_NONE | UART_STOP_BITS_1);
    UARTSetDataRate(UART1, pbClk, DEFAULT_BAUDRATE);
    UARTEnable(UART1, UART_ENABLE_FLAGS(UART_PERIPHERAL | UART_RX | UART_TX));



/*
// original; not tested well
	CloseUART1();
	delay_us(10);
//	UART1ClearErrors();

    // Open UART2 with Receive and Transmitter enable.
    U1BRG = (pbClk/16/DEFAULT_BAUDRATE-1); // calculate actual BAUD generate value.
    U1MODE = UART_EN;
    U1STA = (UART_RX_ENABLE | UART_TX_ENABLE);	

*/

}	


void uart2Init()
{  
	PORTSetPinsDigitalIn(IOPORT_B, BIT_5);	//SET RPB5 to RX  No An
	PORTSetPinsDigitalOut(IOPORT_A, BIT_3);	//SET RPA3 to TX  No An

	mPORTAClearBits(BIT_3);
	mPORTASetBits(BIT_3);
	mPORTAClearBits(BIT_3);
	mPORTASetBits(BIT_3);


    U2RXRbits.U2RXR = 1; //SET RPB5 to RX
    RPA3Rbits.RPA3R = 2; //SET RPA3 to TX


    //UARTConfigure(UART1, UART_ENABLE_PINS_TX_RX_ONLY | UART_ENABLE_PINS_CTS_RTS);	//use this if using hardware flow control
    UARTConfigure(UART2, UART_ENABLE_PINS_TX_RX_ONLY );
    UARTSetFifoMode(UART2, UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY);
    UARTSetLineControl(UART2, UART_DATA_SIZE_8_BITS | UART_PARITY_NONE | UART_STOP_BITS_1);
    UARTSetDataRate(UART2, pbClk, DEFAULT_BAUDRATE);
    UARTEnable(UART2, UART_ENABLE_FLAGS(UART_PERIPHERAL | UART_RX | UART_TX));

}


//BOOL __attribute__((section (".boot_flash"))) charRdy_uart1()
BOOL  charRdy_uart1()
{
	if(U1STAbits.URXDA)
		return(TRUE);
	else
		return(FALSE);

}


BOOL charRdy_uart2()
{
	if(U2STAbits.URXDA)
		return(TRUE);
	else
		return(FALSE);

}


/*
BOOL getChar_uart2(unsigned char *byte)
{
	unsigned char dummy;

	if(U2STA & 0x000E)              // receive errors?
	{
		dummy = U2RXREG; 			// dummy read to clear FERR/PERR
		U2STAbits.OERR = 0;			// clear OERR to keep receiving
	}

	if(U2STAbits.URXDA)
	{
		*byte = U2RXREG;		        // get data from UART RX FIFO
		return TRUE;
	}
	
	return FALSE;

}
*/

//BOOL __attribute__((section (".boot_flash"))) getChar_uart1(unsigned char *byte)
BOOL getChar_uart1(unsigned char *byte)
{
	unsigned char dummy;

	if(U1STA & 0x000E)              // receive errors?
	{
		dummy = U1RXREG; 			// dummy read to clear FERR/PERR
		U1STAbits.OERR = 0;			// clear OERR to keep receiving
	}

	if(U1STAbits.URXDA)
	{
		*byte = U1RXREG;		        // get data from UART RX FIFO
		return TRUE;
	}
	
	return FALSE;

}





//note: uses WriteCoreTimer, so if timing around this fun. pass in 0 for timeOut
// TimeOut delay is max time till start of 1st char or between chars (timer reset between chars)
BOOL getLine_uart1(unsigned char *byte, int maxChars, int timeOut_ms)
{
	unsigned char *chPtr;
	unsigned char ch=0, chRx=0;
	int chCnt = 0;
	BOOL ok;


	chPtr = byte;

	float micro_secs_delay, timeOut_ucrosecs;

	timeOut_ucrosecs = (float)timeOut_ms * 1000.0;

	if(timeOut_ms > 0)
		WriteCoreTimer(0);

	do
	{
		if(charRdy_uart1())
		{
			ok = getChar_uart1(&ch);

			*chPtr = ch;
			chRx = *chPtr;
			chRx = *byte;

			if(chCnt == 0)
			{
				if(ch == '$')
				{
					chCnt++;
					chPtr++;
				}
                                else if(ch == '@')
				{
                                        sprintf((char*)pTxBuf, "Harvester Weigh Wagon Data-Logger 9_17_14\r\n");
                                        SendDataBufferUART1(pTxBuf, strlen(pTxBuf));
                                        return(FALSE);
					//chCnt++;
					//chPtr++;
				}
                                else if(ch == '&')
				{
					chCnt++;
					chPtr++;
				}
                                else if(ch == '#')
				{
					chCnt++;
					chPtr++;
				}
			}
			else
			{

				chCnt++;
	
				if(chCnt > maxChars-1)
					return(FALSE);
				
				
	
				chPtr++;
	
				if(ch == 0x0D)
				{
					chPtr--;  //add this line if you want to erase 0x0D ('\n')
					*chPtr = 0;
					return(TRUE);
				}

			}
			
			//reset timer between chars
			if(timeOut_ms > 0)
				WriteCoreTimer(0);

		}
		


		if(timeOut_ucrosecs > 0)
		{
			//get clock delay
			micro_secs_delay = get_Time_us();

			if(micro_secs_delay > timeOut_ucrosecs)
				return(FALSE);
		}

		



	}while(1==1);




}



void linBus_uart1ClearBuffer()
{
   char  b='f';
	while(charRdy_uart1())
	{
			getChar_uart1(&b);
	}

}


//Tx char, with timeOut (per byte basis), 
//returns byte read if successful (shows that bus wasn't in contention and clears bus from byte we sent)
int linBus_putChar_uart1(unsigned char txChar, unsigned int timeOut_ms)
{
  char  b=0;
  long startTic = 0, stopTic, curTic;

	
	if(timeOut_ms > 20000)
		stopTic = 20000;
	else
	{
		stopTic = 20000 * timeOut_ms;
	}


	WriteCoreTimer(0);		// reset clock

    do
	{
		curTic = ReadCoreTimer();

		if(curTic > stopTic)
			return(0);
	}
	while(U1STAbits.UTXBF); // wait for TX buffer to be empty
    U1TXREG = txChar;

    //need small delay here
	//delay_ms(1);

	WriteCoreTimer(0);		// reset clock

	do
	{
       getChar_uart1(&b);

		curTic = ReadCoreTimer();

		if(curTic > stopTic)  //timeout dependant on
			break;

	}while(b==0);

    curTic = ReadCoreTimer();

	return(b);
}

int linBus_SendDataBufferUART1(const char *buffer, UINT32 size, unsigned int timeOut_ms)
{
  char  b1=0, b2=0;

	while(size)
	{
		b1 = (char)*buffer;
		b2 = linBus_putChar_uart1(*buffer, timeOut_ms);

		if(b1 == b2)
		{
			buffer++;

			size--;
		}
		else
		{
			return(-1);  //return error
		}
	}

	return(1);
}



//void __attribute__((section (".boot_flash"))) putChar_uart1(unsigned char txChar)
void putChar_uart1(unsigned char txChar)
{
    while(U1STAbits.UTXBF); // wait for TX buffer to be empty
    U1TXREG = txChar;
}


void putChar_uart2(unsigned char txChar)
{
    while(U2STAbits.UTXBF); // wait for TX buffer to be empty
    U2TXREG = txChar;
}


//void __attribute__((section (".boot_flash"))) SendDataBufferUART1(const char *buffer, UINT32 size)
void SendDataBufferUART1(const char *buffer, UINT32 size)
{
	while(size)
	{
		//while(!UARTTransmitterIsReady(UART2));

		//UARTSendDataByte(UART2, *buffer);

		putChar_uart1(*buffer);

		buffer++;

		size--;
	}

//	while(!UARTTransmissionHasCompleted(UART2));

}

// works
void SendDataBufferUART2(const char *buffer, UINT32 size)
{
	while(size)
	{
		//while(!UARTTransmitterIsReady(UART2));

		//UARTSendDataByte(UART2, *buffer);

		putChar_uart2(*buffer);

		buffer++;

		size--;
	}

//	while(!UARTTransmissionHasCompleted(UART2));

}



//non-blocking TX; 
//uses global *char *pTxBuf for link to string to transmit
//returns: -1 for still working, 1 for complete, 0 for still working but TX buf still full
int nb_sendDataBufferUART1()
{
  unsigned char b;

		b = *pTxBuf;

		if( (b >= 33)&&(b <= 122) || (b == 0x0A) || (b == 0x0D) )	//only allow alpha numerics and special chars #$#$%@!,
		{
    		if(!U1STAbits.UTXBF)   // if TX buffer is empty, send byte
			{
       			U1TXREG = b;
				pTxBuf++;  //increment buffer

				if(*pTxBuf == 0)
				{
					return(1); //null term found, we're done
				}
				else
				{
					return(-1);  //not done yet
				}
			}
			else
			{
				return(0);
			}
		}
		else  //bad char 
		{
			return(0); 
		}


}


/*

// Non Blocking Version; must be called repeatedly until returns done
static char* bufPtr;
static UINT32 bufSize;
void nb_sendDataBufferUART2(const char *buffer, UINT32 size)
{
  unsigned char txChar;

	bufPtr = buffer;
	bufSize = size;

	txChar = *bufPtr;	

    while(U2STAbits.UTXBF); // wait for TX buffer to be empty
    U2TXREG = txChar;

	bufPtr++;
	bufSize --;
}

int nb2_sendDataBufferUART2()
{
  unsigned char txChar;

	if(bufSize)
	{
		txChar = *bufPtr;	
	
	    while(U2STAbits.UTXBF); // wait for TX buffer to be empty
	    U2TXREG = txChar;
	
		bufPtr++;
		bufSize --;
		
		return(1);
	}
	else
	{
		return(2);	//all done sending buffer

	}

}

*/


/*
UINT32 GetDataBufferUART2(char *buffer, UINT32 max_size)
{
  UINT32 num_char;


	num_char = 0;

	while(num_char < max_size)
	{

		UINT8 character;

		//while(!UARTReceivedDataIsAvailable(UART2));

		//character = UARTGetDataByte(UART2);

		
		getChar_uart2(&character);

		if(character == '\r');
			break;

		*buffer = character;

		buffer++;
		num_char++;

	}

	return num_char;
  
}
*/